<template>
   <div id="app" class="container">
    <div class="page-header">
    </div>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title">Adicionar Produtos</h3>
        <h5>Cliente: {{account.user_name}} - Mês: {{account.month}}</h5>
        <hr>
      </div>
      <div class="panel-body">
         <b-form id="form" class="form-inline" v-on:submit.prevent="updateAccount">
          <div class="form-group">
            <label for="productName">Produtos:</label>
            <select class="form-control" id="productName" v-model="newProductsArray.product_id">
                <option v-for="product in products" v-bind:key="product['.key']" :value="product['.key']">{{product.name}}</option>
            </select>
          </div>
          <div class="form-group">
            <label for="productQuantity">Quantidade:</label>
            <input type="number" id="productQuantity" class="form-control" v-model="newProductsArray.quantity"/>
          </div>
       <input type="submit" class="btn btn-primary" value="Adicionar">
        </b-form>
      </div>
    </div>
    <br>
    <br>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title">Lista de Produtos</h3>
      </div>
      <div class="panel-body">
        <table class="table table-striped">
          <thead>
            <tr>
              <th>Nome</th>
              <th>Quantidade</th>
              <th>Ações</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(product, index) in account.productsArray" :key="index">
              <td>{{product.product_name}}</td>
              <td>{{product.quantity}}</td>
              <td>
                <span class="btn btn-primary" v-on:click="removeProduct(account, index)">Remover</span>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import toastr from "toastr";
import { db } from "/home/carolina/Documentos/zrp/repositorios/account-manager/src/config/db";
import { functions } from "firebase";

let productsRef = db.ref("products");
let accountsRef = db.ref("accounts");

export default {
  name: "EditAccount",
  firebase: {
    products: productsRef
  },
  data() {
    return {
      newProductsArray: {
        product_id: "",
        quantity: ""
      }
    };
  },
  methods: {
    updateAccount: function() {
      const products = this.products.filter(
        product => product[".key"] === this.newProductsArray.product_id
      );
      const [product] = products;

      this.newProductsArray.product_name = product.name;
      const finalValue = product.price * this.newProductsArray.quantity;
      
      accountsRef.child(this.$route.params.id).transaction(account => {
        if (!account.productsArray) {
          account.productsArray = [];
        }
        account.productsArray.push(this.newProductsArray);
        const previousAmount = account.amount;
        account.amount += finalValue;

        return account;
      });

      this.$router.push("/accounts");
      toastr.success("Conta atualizada");
    },
    removeProduct: function(account, index) {
      const removeProductId = account.productsArray[index].product_id;
      const removeProductQuantity = account.productsArray[index].quantity;
      const product = this.products.find(
        item => item[".key"] === removeProductId
      );
      const finalValue = product.price * removeProductQuantity;
      const newArray = account.productsArray;
      newArray.splice(index, 1);

      const previousAmount = account.amount;
      const newAmount = previousAmount - finalValue;

      accountsRef.child(this.$route.params.id).transaction(account => {
        account.productsArray = newArray;
        account.amount = newAmount;

        return account;
      });

      this.$router.push("/accounts");
      toastr.success("Lista de produtos atualizada");
    }
  },
  created() {
    this.$bindAsObject("account", db.ref("accounts/" + this.$route.params.id));
  }
};
</script>

<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>

